%global timestamp 20181101
%global debug_package %{nil}

Name: chia_bls
Version: 0.0.%{timestamp}
Release: 4%{?dist}.1
Summary: BLS signatures in C++, using the relic toolkit
License: ASL 2.0
URL: https://github.com/dashpay/bls-signatures
Source0: https://github.com/dashpay/bls-signatures/archive/v%{timestamp}/bls-signatures-%{timestamp}.tar.gz
BuildRequires: gmp-devel

%if 0%{?rhel}  == 7
BuildRequires:  cmake3
%else
BuildRequires:  cmake
%endif

%description
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%package devel
Summary: BLS signatures in C++, using the relic toolkit
Requires: gmp-devel

%description devel
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%prep
%setup -n bls-signatures-%{timestamp}

%build
%{__mkdir} build
cd build
%{cmake3} \
    -DSTLIB=ON \
    -DSHLIB=OFF \
    -DSTBIN=ON \
    -DOPSYS=LINUX \
    -DCMAKE_SYSTEM_NAME=Linux \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    ..

%{?cmake3_build}%{?!cmake3_build:%{make_build}}

%install
cd build
%{?cmake3_install}%{?!cmake3_install:%{make_install}}
if [ '/usr/lib' != '%{_libdir}' ]; then
  %{__mv} '%{buildroot}/usr/lib' '%{buildroot}%{_libdir}'
fi
%{__mkdir_p} %{buildroot}%{_datadir}/cmake
%{__mv} %{buildroot}/usr/cmake %{buildroot}%{_datadir}/cmake/Modules

%check
cd build
%{?__cmake_builddir:cd %{__cmake_builddir}}
./src/runtest
./src/runbench

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/*
%{_datadir}/cmake/Modules/*
%changelog
* Wed Oct 30 2019 Oleg Girko <ol@infoserver.lv> - 0.0.20181101-4
- Fix a typo in in macros used to build
* Mon Oct 28 2019 Oleg Girko <ol@infoserver.lv> - 0.0.20181101-3
- Update URL
- Use proper macros to build, install and run tests
* Tue Jan 22 2019 Oleg Girko <ol@infoserver.lv> - 0.0.20181101-2
- Make devel subpackage require gmp-devel
* Tue Jan 22 2019 Oleg Girko <ol@infoserver.lv> - 0.0.20181101-1
- Initial import
